{                  New Year Contest ' 1996-97
                             .
                            ...
                           .....
                          .......
                         .........
                            ...

                    ணࠬ
}

{$A-,B-,D+,E-,F+,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,500000}

program NEW_YEAR;
uses DOS, CRT;

Const AllSolutions = '*.TUR';
      AllTests     = '*.TST';
      MaxPossibleActions = 1000000;

Const MaxStates = 3000;
      MSize = 30000;
      OutSize = 55520;
      ErrorInt = -9999;

const TooManyActions = 'ॢ襭 ᨬ쭮 ⨬ ᫠ 蠣';

const _0 = 0;
      _1 = 1;
      _E = 2;

type TValue = word;
     TM = array [1..MSize] of word;
     TOut = array [1..OutSize] of char;
     TTableElem = record
                          q: word;                 {+0}
                          e: TValue;               {+2}
                          Shift: shortint;         {+4}
                          o: char;                 {+5}
                       end;

     TTableRow = array [0..2] of TTableElem;
     TTable = array [0..MaxStates] of TTableRow;

const TableRowLength = sizeof (TTableRow);
      TableElmLength = sizeof (TTableElem);

var
    TURING_ERROR: boolean;
    TURING_MESSAGE: string;

    M: ^TM; OUT: ^TOut;
    MFrom, MTo, MPtr, MStartPtr: word;
    MPtrREF: ^TValue;
    Table: TTable;

    OutPtr: word;
    MValuesOnScreen: integer;
    MWindowPtr: longint;

    N: integer;
    CurState, StartState: integer;

    Actions: longint;

function VisualValue (v: TValue): char;
begin
   case v of
     _0: VisualValue := '0';
     _1: VisualValue := '1';
     _E: VisualValue := 'E';
   else
       VisualValue := '?';
   end;
end;

function Str (x: longint; w: integer): string;
var help: string; rc: integer;
begin
   System.Str (x:w, help);
   Str := help
end;

procedure Split (s: string; c: char; var s1, s2: string);
var i, j: integer;
begin
   i := 1; while (i <= length (s)) and (s [i] =  ' ') do inc (i);
   j := i; while (j <= length (s)) and (s [j] <> c) do inc (j);
   s1 := copy (s, i, j-i);
   s2 := copy (s, j+1, length (s)-j);
end;

function compress (s: string): string;
begin
   while (length (s) > 1) and (s [1] = ' ') do delete (s, 1, 1);
   while (length (s) > 1) and (s [length(s)] = ' ') do delete (s, length(s), 1);
   compress := s
end;

procedure QUIT (msg: string);
begin
   if not TURING_ERROR then
   begin
      TURING_ERROR := True;
      TURING_MESSAGE := msg
   end;
end;

procedure ERROR (msg: string);
begin
   writeln;
   writeln (#7, msg);
   HALT (1)
end;

procedure RIGHT;
begin
        inc (MPtr);
        inc (MPtrREF);
        if MPtr > MTo then
        begin
           if MPtr > MSize then
           begin
              QUIT ('Too many cells are used on tape M');
              exit
           end;
           MTo := MPtr;
           MPtrREF^ := _E
        end;
end;

procedure LEFT;
begin
   dec (MPtr);
   dec (MPtrREF);
   if MPtr < MFrom then
   begin
      if MPtr < 1 then
      begin
         QUIT ('Line M is too long');
         exit
      end;
      MFrom := MPtr;
      MPtrREF^ := _E
   end;
end;

procedure WriteOut (o: char);
begin
   inc (OutPtr);
   if OutPtr > OutSize then
   begin
      QUIT ('Too many values has been written to the output tape');
      exit
   end;
   Out ^ [OutPtr] := o
end;

function OutLen: word;
begin
   OutLen := OutPtr;
end;

function GetOut (i: integer): char;
begin
   if (i < 1) or (i > OutPtr) then ERROR ('Out of rang on the tape OUT');
   GetOut := Out ^ [i];
end;

procedure WriteM (v: TValue);
begin
   M^ [MPtr] := v
end;

function VisualNextMove: string;
var help: string;
begin
   with Table [CurState, M^ [MPtr]] do
    if q <> 0 then
    begin
      help := '(' + Str (q, 0) + ', "' + VisualValue (e) + '") Move = ' + Str (shift, 0);
      if o <> ' 'then help := help + ' out = "' + o + '"';
      VisualNextMove := help;
    end
    else VisualNextMove := 'no rule defined';
end;

var e, e1: TValue;
    q, q1: integer;
    move: integer;
    sq, se, sq1, se1, smove, sout: string;
    RepeatRules: boolean;
    ch: char;
    Trace, WaitKeyPressed: boolean;
    LastActions: longint;
    instringfile: TEXT;
    LNumber: longint;

    procedure IR;
    begin
        QUIT ('Wrong rule found at line ' + Str (LNumber, 0));
    end;

    function IntValue (s: string): integer;
    var help: string; rc: integer; res: integer;
    begin
       Val (s, res, rc);
       if rc <> 0 then IR ;
       IntValue := res
    end;

    function CharValue (s: string): char;
    begin
       if length (s) <> 1 then IR ;
       CharValue := s [1]
    end;

    function MValue (s: string): TValue;
    begin
      case upcase (CharValue (s)) of
        '1': MValue := _1;
        '0': MValue := _0;
        'E': MValue := _E;
        else QUIT ('unknown symbols: "' + s + '"');
      end;
    end;

procedure COMPILE (fname: string);
var help, bsk: string;
    i, j: integer;
    e, e1: TValue;
    q, q1: integer;
    move: integer;
    sq, se, sq1, se1, smove, sout: string;
    inf: TEXT;

begin
   assign (inf, fname); reset (inf);

   LNumber := 0;
   repeat
       if eof (inf) then QUIT ('Eof found: missing number of Machine''s states');
       ReadLn (inf, HELP);
       inc (LNumber);
       split (help, ';', help, BSK);
   until help <> '';

   N := IntValue (help);
   if TURING_ERROR then exit;

   if N < 0 then QUIT ('The number of states N must be greater than 0');
   if N > MaxStates then QUIT ('The number of states N must be not greater than ' + Str (MaxStates, 0));

   repeat
       if eof (inf) then QUIT ('Eof found: Missing initial state');
       readln (inf, Help); inc (LNumber);
       split (help, ';', help, BSK);
   until help <> '';

   StartState := IntValue (help);
   if TURING_ERROR then exit;

   if (StartState <=  0) or (StartState > N) then QUIT ('Invalid intial state S');
   if TURING_ERROR then exit;

   {樠 ⠡ 室}
   for i := 1 to N do
     for e := _0 to _E do Table [i,e].q := 0;

   while not eof (inf) do
   begin
      inc (LNumber);

      ReadLn (inf, help);

      split (help, ';', help, BSK);

      split (help, ' ', sq, help);
      split (help, ' ', se, help);
      split (help, ' ', sq1, help);
      split (help, ' ', se1, help);
      split (help, ' ', smove, help);
      split (help, ' ', sout, help);

      if sq <> '' then begin
         if sout = '' then sout := ' ';
         sout := CharValue (Sout);
         q := IntValue (sq);
         if TURING_ERROR then exit;
         e := MValue (se);
         if TURING_ERROR then exit;
         q1 := IntValue (sq1);
         if TURING_ERROR then exit;
         e1 := MValue (se1);
         if TURING_ERROR then exit;
         move := IntValue (smove);
         if (q < 0) or (q > N) or (q1 < 0) or (q1 > N) or
            ( not (sout [1] in ['1','0', ' '])) or (move < -1) or (move > 1) then
         IR;
         if TURING_ERROR then exit;

         if Table [q, e] . q <> 0 then
            QUIT ('Line ' + Str (LNumber, 0) + ' contains already defined rule');
         if TURING_ERROR then exit;

         Table [q, e] . q := q1;
         Table [q, e] . e := e1;
         Table [q, e] . shift := move;

         Table [q, e] . o := CharValue (sout [1]);
         if TURING_ERROR then exit;
      end;
   end;

   close (inf);

end; {COMPILE}

function AliLeft (s: string; width: integer): string;
begin
   while length (s) < width do s := s + ' ';
   AliLeft := copy (s, 1, width);
end;

const LastFileName: string = '3987t38476983769847987';
      LastCompileMessage: string = '';
      LastCompileError: boolean = false;

procedure EXITPROGRAM;
begin
   Window (1, 1, 80, 25);
   GotoXY (80, 25);
   TextColor (LightGray);
   Writeln;
   HALT;
end;

procedure INTERPRETER (fname: string; instring: string;
                      MaxMoves: longint; var Actions: longint);
Label StartLOOP, L_01, L_02, L_03, L_04;
var i, LOOPBound: longint;
    resstr: string;
    k: integer;
    Counter: word;

    LOCAL: TTableElem;
    Extra_byte: byte;

    LOCAL_REF: ^TTableElem;

    procedure WriteI (i: longint);
    var x, y: integer;
    begin
       x := WhereX; y := WhereY;
       write (AliLeft (Str (i, 0), 8));
       GotoXY (x, y);
    end;

begin
   TURING_ERROR := false; { 訡 }
   TURING_MESSAGE := '';  { 直 砩 :-) }

   if LastFileName = fname then
   begin
      TURING_ERROR := LastCompileError;
      TURING_MESSAGE := LastCompileMessage
   end
   else begin
      COMPILE (fname);
      LastCompileError := TURING_ERROR;
      LastCompileMessage:= TURING_MESSAGE;
      LastFileName := fname
   end;

   if TURING_ERROR then exit;

   MPtr := MSize div 2;
   MStartPtr := MPtr;
   MWindowPtr := MPtr - 1;
   MFrom := MPtr; MTo := MPtr;
   MPtrREF := @ M^ [MPtr];
   MPtrREF^ := _E;

   MPtr := MStartPtr;

   {뢠 室 }
   for i := 1 to length (instring) do
   begin
      WriteM (MValue (instring [i]));
      if i <> length (instring) then RIGHT
   end;

   MPtr := MStartPtr;
   MPtrREF := @ M^ [MPtr];

   CurState := StartState;

   OutPtr := 0; {室   }
   Counter := 0;

   LOCAL_REF := @LOCAL;

(*
   for i := 1 to MaxMoves+1 do { ᨬ쭮 ⢠ 室}
*)

   i := 1;
   LoopBound := MaxMoves + 1;

   StartLoop:

   begin
      inc (Counter);

      (* 1 蠣 .. 믮塞 ਬ୮  24  *)

      asm
          imul si, CurState, TableRowLength
          les  di, MPtrREF
          imul bx, word ptr es:[di], TableElmLength

          {add si, bx}

          (*  TTableElem = record
                               q: word;                 {+0}
                               e: TValue;               {+2}
                               Shift: shortint;         {+4}
                               o: char;                 {+5}
                           end;
          *)

          mov ax, [si+bx+offset(TABLE)+0] {ax := q}
          mov CurState, ax             {CurState := q}
          or  ax, ax
          jnz L_01                     {IF CurState <> 0 GOTO @@1}
      end;
             Actions := i-1;
             exit {室};
      L_01:
      asm
          mov ax, [si+bx+offset(TABLE)+2] {ax := e}
          (* les di, MPtrREF *)
          mov word ptr es:[di], ax     {MPtrREF^ := e}
          cmp byte ptr [si+bx+offset(TABLE)+5], ' '
          jz  L_02                     {IF o = ' ' GOTO @@2}

          mov al, [si+bx+offset(TABLE)+5]
          mov LOCAL.o, al
          pusha
      end;
          WriteOut (LOCAL.o);
          asm popa end;

      L_02:
      asm
          cmp byte ptr [si+bx+offset(TABLE)+4], 0
          jg  L_03
          jz  L_04
      end;
         dec (MPtr);
         dec (MPtrREF);
         if MPtr < MFrom then
         begin
            if MPtr < 1 then
            begin
               QUIT ('Too many cells are used on tape M');
               exit
            end;
            MFrom := MPtr;
            MPtrREF^ := _E
         end;
      asm
          jmp L_04
          L_03:
      end;
         inc (MPtr);
         inc (MPtrREF);
         if MPtr > MTo then
         begin
            if MPtr > MSize then
            begin
               QUIT ('Too many cells are used on tape M');
               exit
            end;
            MTo := MPtr;
            MPtrREF^ := _E
         end;

      L_04:

      if (Counter = 50000) then
      begin
         WriteI (i);
         if keypressed and (readkey = #27) then
         begin
            writeln;
            writeln;
            write ('EXECUTION TERMINATED');
            EXITPROGRAM;
         end;
         Counter := 0;
      end;

   end;

   { i := i+1, ஢ઠ i <= MaxMoves + 1 }
   asm
       db $66; inc word ptr i;     { i := i+1 }
       db $66; mov ax, word ptr i  { ax := i }
       db $66; cmp ax, word ptr LoopBound
       jle StartLoop
   end;

   QUIT (TooManyActions);
end;

(* ======================================================== *)
(*                                            *)
(* ======================================================== *)

function CHECK_ANS (s: string): boolean;
var Null: boolean;
    carry: integer;
    i: integer;
    OP: word;
begin
   OP := OutLen;
   CHECK_ANS := false;
   repeat
      carry := 0;
      Null := True;
      for i := 1 to length (s) do
      begin
         carry := carry * 2 + ord (s [i]) - ord ('0');
         s [i] := chr (carry div 10 + ord ('0'));
         carry := carry mod 10;
         Null := Null and (s [i] = '0');
      end;

      for i := 1 to 4 do
      begin
         if OP = 0 then exit;
         if chr (carry mod 2 + ord ('0')) <> GetOut (OP) then exit;
         dec (OP);
         carry := carry div 2
      end;

   until Null;

   CHECK_ANS := OP = 0; {!!!}
end;

(* ======================================================= *)
(*  ( )                       *)
(* ======================================================= *)

PROCEDURE M_A_I_N;

Const MaxSolutions = 25;
      MaxTests     = 10;
      MaxFiles     = (abs (MaxSolutions - MaxTests) + MaxSolutions + MaxTests) div 2;

Type String80    = string [80];
     StringArray = array [1..MaxFiles] of string80;
     TestingResult = (_OK, _WA, _TL, _PE);

Var TestNameArray, SolNameArray: StringArray;
    Tests, Solutions: integer;
    University, Participant: StringArray;
    ShortUniversity: array [1..MaxSolutions] of string [20];
    TestString: array [1..MaxTests] of string [255];

    RES: array [1..MaxSolutions] of record
                                       Accepted: integer; {⢮ 襤 ⮢}
                                       Actions: array [1..MaxTests] of longint;
                                       SumActions: longint;
                                       T: array [1..MaxTests] of TestingResult;
                                    end;
    enum: array [1..MaxSolutions] of 1..MaxSolutions;

procedure SortFileArray (var A: StringArray; N: integer);
var i, j, k: integer;
    x: string;
begin
   for i := 1 to N-1 do
   begin
      k := i;
      for j := i+1 to N do
        if A [j] < A [k] then k := j;
      x := A [k]; A [k] := A [i]; A [i] := x
   end;
end;

procedure ReadFileArray (WildCard: string; var A: StringArray; var N: integer);
var SR: SearchRec;

    function GetPath (s: string): string;
    var i: integer;
    begin
       i := length (s);
       while (i > 0) and (s [i] <> '\') do dec (i);
       if i = 0 then GetPath := ''
       else GetPath := copy (s, 1, i);
    end;

begin
   FindFirst (WildCard, Archive, SR);
   N := 0;
   while DosError = 0 do
   begin
      N := N+1;
      A [N] := GetPath (WildCard) + SR.name;
      FindNext (SR);
   end;
end;


function AliRight (s: string; width: integer): string;
begin
   while length (s) < width do s := ' ' + s;
   AliRight := copy (s, 1, width);
end;

function AliCenter (s: string; width: integer): string;
begin
   while length (s) < width do
     if odd (length (s)) then s := s + ' '
                        else s := ' ' + s;
   AliCenter := copy (s, 1, width);
end;

function DELNumber (s: string): string;
var i: integer;
begin
   i := length (s);
   while (i>0) and (s [i] in ['0'..'9', ' ']) do dec (i);
   if (i = 0) or (s [i] <> '-') then DELNumber := s
   else DELNumber := compress (copy (s, 1, i-1));
end;

procedure HR (var T: Text);
var i: integer;
begin
   for i := 1 to 79 do write (T, '-');
   writeln (T);
end;

function repeatstr (s: string; count: integer): string;
var res: string;
    i: integer;
begin
   res := ''; for i := 1 to count do res := res + s;
   repeatstr := res
end;

procedure Accepted (msg: string);
begin
   TextColor (LightGreen);
   write ('* Accepted * '); TextColor (LightGray); writeln (msg);
end;

procedure Rejected (msg: string);
begin
   TextColor (LightRed);
   write ('* Rejected * '); TextColor (LightGray); writeln (msg);
end;

procedure WriteXY (x, y: integer; s: string);
begin
   gotoxy (x, y); write (s)
end;

var i, j, k: integer;
    SFile: TEXT;
    help, help1: string;
    HisResult: string;
    HisActions: longint;
    ouf: TEXT;
    helpint: integer;

    _width_test: integer;
    _width_name: integer;
    _width_acc : integer;
    _width_uni : integer;

BEGIN
   Writeln (MemAvail);
   New (M); New (Out);

   ReadFileArray (AllSolutions, SolNameArray, Solutions);
   ReadFileArray (AllTests, TestNameArray, Tests);
   SortFileArray (SolNameArray, Solutions);
   SortFileArray (TestNameArray, Tests);

   clrscr;

   TextColor (White);
   writeln ('                   " 1996-97');
   TextColor (Yellow);
{   Writeln (AliLeft ('஢ ணࠬ', 40));}
   TextColor (LightGray);
   writeln;
   writeln (' ', Solutions:3, ' 襭 : ', AllSolutions, '');
   writeln (' ', Tests:3,     ' ⮢  : ', AllTests, '');
   writeln;
   writeln (' 뢠 ࠡ  ESC');
   TextColor (Cyan);

   Window (70, 1, 80, 10);

   TextColor (LightGreen);
   for i := 1 to 5 do
      Writeln (AliCenter (repeatstr ('.', 2*i-1), 10));
   Writeln (AliCenter ('...', 10));

   TextColor (LightGray);

   Window (1, 1, 80, 25);
   TextColor (Cyan);

   WriteXY (1, 7, repeatstr ('', 79));
   WriteXY (1, 25, repeatstr ('', 79));
   for j := 8 to 24 do WriteXY (1, j, '');
   for j := 8 to 24 do WriteXY (79, j, '');
   WriteXY (1,  7, '');
   WriteXY (79, 7,  '');
   WriteXY (1,  25, '');
   WriteXY (79, 25 , '');

   TextColor (LightGray);

   Window (3, 8, 78, 24);

   for i := 1 to Solutions do
   begin
      assign (SFile, SolNameArray [i]); reset (SFile);
      help := '';
      while (not eof (SFile)) and (compress (help) = '') do readln (SFile, help);

      split (copy (help, 2, 255), '(', help1, help);
      University [i] := compress (help1);
      split (help, ')', help1, help);
      ShortUniversity [i] := compress (help1);

      help := '';
      while (not eof (SFile)) and (compress (help) = '') do readln (SFile, help);
      Participant [i] := compress (copy (help, 2, 255));
      close (SFile);
   end;

   for i := 1 to Tests do
   begin
      assign (SFile, TestNameArray [i]); reset (SFile);
      help := '';
      while (not eof (SFile)) and (compress (help) = '') do readln (SFile, help);
      TestString [i] := compress (help)
   end;

   (*  ... *)

   FOR i := 1 to Solutions DO
   BEGIN
      RES [i].Accepted := 0;
      RES [i].SumActions := 0;
      {TextColor (Yellow);}
      Writeln (' "', SolNameArray [i] + '" (' + Participant [i] + ', ', ShortUniversity [i], ')');
      TextColor (LightGray);
      for j := 1 to Tests do
      begin
         write ('    ', j:2, ' ');
         INTERPRETER (SolNameArray [i], TestString [j],
                      MaxPossibleActions, HisActions);

         if Turing_Error then
         begin
            Rejected (Turing_Message);
            if Turing_Message = TooManyActions then
               RES [i]. T [j] := _TL
            else
               RES [i]. T [j] := _PE
         end

         else if CHECK_ANS (TestString [j]) then
         begin
            Accepted (': ' + Str (HisActions, 0));
            inc (RES [i].Accepted);
            RES [i]. T [j] := _OK;
            RES [i]. Actions [j] := HisActions;
            inc (RES [i]. SumActions, HisActions);
         end

         else begin
            Rejected (' ⢥');
            RES [i]. T [j] := _WA
         end
      end;
      writeln;
   END;

   (*    *)

   for i := 1 to Solutions do enum [i] := i;

   for i := 1 to Solutions-1 do
   begin
      k := i;
      for j := i+1 to Solutions do
        if  (RES [enum [j]].Accepted > RES [enum [k]].Accepted) or
           ((RES [enum [j]].Accepted = RES [enum [k]].Accepted) and
             (RES [enum [j]].SumActions < RES [enum [k]].SumActions))
        then k := j;

        helpint := enum [k]; enum [k] := enum [i]; enum [i] := helpint;
   end;

   assign (ouf, 'RESULT.TXT'); rewrite (ouf);

   _width_test := 7;
   _width_name := 20;
   _width_acc  := 5;
   _width_uni  := 10;

   write (ouf, '    ', AliLeft ('', _width_name + _width_uni));
   for j := 1 to Tests do
     write (ouf, AliRight (' ' + Str (j, 0), _width_test));

   writeln (ouf, AliCenter ('', _width_acc), AliRight ('㬬', _width_test));
   writeln (ouf);

   for i := 1 to Solutions do
   begin
      write (ouf, i:2, '. ', AliLeft (Participant [enum[i]], _width_name));
      write (ouf, AliLeft (ShortUniversity [enum[i]], _width_uni));
      for j := 1 to Tests do
      begin
         case RES [enum [i]]. T [j] of
           _OK: write (ouf, RES [enum [i]].Actions [j]: _width_test);
           _PE: write (ouf, AliRight ('PE', _width_test));
           _TL: write (ouf, AliRight ('TL', _width_test));
           _WA: write (ouf, AliRight ('WA', _width_test));
        end;
      end;

      write (ouf, '  (', RES [enum[i]].Accepted, ')',
                 AliRight (Str (RES [enum[i]].SumActions, 0),_width_test));
      writeln (ouf);

      if i = 3 then writeln (ouf)
      else if ((i<Solutions) and (RES [enum[i+1]].Accepted <> RES [enum[i]].Accepted))
      then writeln (ouf)

   end;

   writeln (ouf);
   writeln (ouf, '* TL 砥,  믮 뫮 ࢠ ᫥ ', MaxPossibleActions, ' 蠣');
   writeln (ouf);

   HR (ouf);
   writeln (ouf);
   writeln (ouf, ' N    ୮ (᫮  ࠧ冷)');
   writeln (ouf);
   for j := 1 to Tests do
     writeln (ouf, j:3, '           ', length (TestString [j]):0);

   writeln (ouf);

   HR (ouf);

   writeln (ouf);
   writeln (ouf, '஢ ᮪饭  㭨⮢:');
   writeln (ouf);

   for i := 1 to Solutions do
   begin
      ShortUniversity [i] := DELNumber (ShortUniversity [i]);
      University [i] := DELNumber (University [i]);
   end;

   for i := 1 to Solutions do enum [i] := i;

   for i := 1 to Solutions-1 do
   begin
      k := i;
      for j := i+1 to Solutions do
        if  ShortUniversity [enum [j]] < ShortUniversity [enum [k]]
        then k := j;
        helpint := enum [k]; enum [k] := enum [i]; enum [i] := helpint;
   end;

   for i := 1 to Solutions do
     if (i = 1) or (ShortUniversity [enum [i]] <> ShortUniversity [enum[i-1]]) then
        writeln (ouf, AliLeft (ShortUniversity [enum [i]], _width_uni),
        ' = ', University [enum [i]]);

   writeln (ouf);
   close (ouf);

   writeln;
   writeln (' ஢ 뢥  䠩 RESULT.TXT');
   EXITPROGRAM;
END {M_A_I_N};

begin
   M_A_I_N
end.